;==========================================================
; LOFFSET.LSP 
; Copyright 1993,1994 by Looking Glass Microproducts
;==========================================================
; This routine offsets entitities to the current layer,
; color, and linetype
;==========================================================
(defun C:LOFFSET (/ OLD_ERROR ERROR REPLACE NOTRANS LOFFSET)
   ;=======================================================
   ; Error Handler
   ;=======================================================
   (defun ERROR (S)
      (if (not
             (member
                S
                '("Function cancelled" "console break")
             )
          )
         (alert S)
      )
      (setvar "cmdecho" 0)
      (command ".undo" "end")
      (setq *error* OLD_ERROR)
      (princ)
   )
   ;=======================================================
   ; Replace or Append entry in association list
   ;=======================================================
   (defun REPLACE (ENTRY ALIST / OLD_ENTRY)
      (if (setq OLD_ENTRY (assoc (car ENTRY) ALIST))
         (subst
            ENTRY
            OLD_ENTRY
            ALIST
         )
         (append ALIST (list ENTRY))
      )
   )
   ;=======================================================
   ; Disallow transparent invocation of routine.
   ;=======================================================
   (defun NOTRANS ()
      (cond
         ((zerop (logand (getvar "cmdactive") (+ 1 2 4 8))))
         ((alert
            "This command may not be invoked transparently."
          )
         )
      )
   )
   ;=======================================================
   ; Main Routine
   ;=======================================================
   (defun LOFFSET (/ OFFSETDIST PRMPT LASTENT ENT CLAYER 
                     CELTYPE CECOLOR)
      (setq
         CLAYER     (cons 8 (getvar "clayer"))
         CELTYPE    (cons 6 (getvar "celtype"))
         CECOLOR    (getvar "cecolor")
         CECOLOR    (cons
                       62
                       (cond
                          ((= "BYBLOCK" CECOLOR) 0)
                          ((= "BYLAYER" CECOLOR) 256)
                          ((atoi CECOLOR))
                       )
                    )
         OFFSETDIST (getvar "offsetdist")
         LASTENT    (entlast)
      )
      (setq
         PRMPT (strcat
                  "\nOffset distance or Through <"
                  (if (> OFFSETDIST 0)
                     (rtos OFFSETDIST)
                     "Through"
                  )
                  ">: "
               )
      )
      (command ".offset")
      (setvar "cmdecho" 1)
      (prompt PRMPT)
      (command pause)
      (while (/= 0 (getvar "cmdactive"))
         (command pause)
         (if (not (equal LASTENT (entlast)))
            (progn
               (setq
                  LASTENT (entlast)
                  ENT     (REPLACE
                             CLAYER
                             (REPLACE
                                CELTYPE
                                (REPLACE
                                   CECOLOR
                                   (entget LASTENT)
                                )
                             )
                          )
               )
               (entmod ENT)
            )
         )
      )
   )
   ;=======================================================
   ; Start of main program
   ;=======================================================
   (if (NOTRANS)
      (progn
         (setq OLD_ERROR *error* *error* ERROR)
         (setvar "cmdecho" 0)
         (command ".undo" "group")
         (LOFFSET)
         (setvar "cmdecho" 0)
         (command ".undo" "end")
         (setq *error* OLD_ERROR)
      )
   )
   (princ)
)
(princ
   (strcat
      "  LOFFSET.LSP v1.0 (Copyright 1993,1994 by "
      "Looking Glass Microproducts) loaded."
   )
)
(princ)
