; SWDU8.LSP VR12.0
; Drawing Title Sheet Setup Dialog
; Copyright Barry R. Bowen 1993-94
; 3394 Coleman Rd., Memphis, TN 38128
; For AutoCAD R12 only

(defun C:SWDU8 (/ UNITS PEC X X1 Y Y1 SF BOR BASBR SNPSZ GRDSZ
  GRD ORTH SNAPM BLIP HIGHL SLIST1 SLIST2 SLIST3 SLIST4 SLIST5
  SLIST6 SLIST7 SLIST8 dcl_id FILE LINE LINE0 LINE1 LINE2 LINE 3 LINE4
  BRLIST0 BRLIST1 BRLIST2 BRLIST3 BRLIST4 UP_SCL SCALE LTSCL DIMSCL
  DO_PREC UNT SCLE DO_SCALE SCALE SHTSZ BRSHT PAPSP XREF INITITL do_next
  EZBOR EZCK ZSF INTITL)

; ---------------- Pre-set Required Variables
  (setq UNITS "0" PEC "0" X 36 Y 24 SF 48 BOR "SWDU8.TSF" BASBR nil
        SNPSZ "1" GRDSZ "0" GRD "0" GRD1 "0" ORTH "1" SNAPM "0" BLIP "0"
        HIGHL "1" DIMSCL 48.0 LTSCL 24.0 SCALE "2" BRSHT "0"
        SLIST1 (list "Architectural" "Engineering")
        SLIST2 (list " 0'-0" " 0'-0 1/2" " 0'-0 1/4" " 0'-0 1/8"
                     " 0'-0 1/16" " 0'-0 1/32" " 0'-0 1/64")
        SLIST3 (list " 0'-0" " 0'-0.0" " 0'-0.00" " 0'-0.000"
                     " 0'-0.0000" " 0'-0.00000" " 0'-0.000000")
        SLIST4 (list " FULL"
                     (strcat "  1/8"(chr 34)" = 1'-0"(chr 34))
                     (strcat "  1/4"(chr 34)" = 1'-0"(chr 34))
                     (strcat "  3/8"(chr 34)" = 1'-0"(chr 34))
                     (strcat "  1/2"(chr 34)" = 1'-0"(chr 34))
                     (strcat "  3/4"(chr 34)" = 1'-0"(chr 34))
                     (strcat "    1"(chr 34)" = 1'-0"(chr 34))
                     (strcat "1 1/2"(chr 34)" = 1'-0"(chr 34))
                     (strcat "    3"(chr 34)" = 1'-0"(chr 34))
                     (strcat "    6"(chr 34)" = 1'-0"(chr 34)))
        SLIST5 (list " FULL" "1 = 1'-0" "1 = 10'-0" "1 = 20'-0"
                     "1 = 30'-0" "1 = 40'-0" "1 = 50'-0"
                     "1 = 60'-0")
        SLIST6 (list "8 1/2 x 11" "   11 x 17" "   17 x 22"
                     "   18 x 24" "   22 x 34" "   24 x 36" "   30 x 42"
                     "   36 x 48")
        SLIST7 (list "1" "2" "4" "6" "8" "10" "12") ;snap
        SLIST8 (list "12" "24" "36" "48" "60") ;grid
  )

; ---------------- Initialize Dialog Box and Pipe Sizes
  (setq dcl_id (load_dialog "swdu8.dcl"))
  (if (not (new_dialog "swdu8" dcl_id)) (exit))
  (setq FILE (open BOR "r"))
  (repeat 4
    (setq LINE (read-line FILE))
  )
  (setq BRLIST0 '() BRLIST1 '() BRLIST2 '() BRLIST3 '() BRLIST4 '())
  (while LINE
    (setq LINE (read LINE)
          LINE0 (nth 0 LINE)
          LINE1 (nth 1 LINE)
          LINE3 (nth 2 LINE)
          LINE4 (nth 3 LINE)
          BRLIST0 (append (list LINE0) BRLIST0)
          BRLIST1 (append (list LINE1) BRLIST1)
          BRLIST3 (append (list LINE3) BRLIST3)
          BRLIST4 (append (list LINE4) BRLIST4)
          LINE2 (strcat LINE0 LINE1)
          BRLIST2 (append (list LINE2) BRLIST2)
          LINE (read-line FILE))
  )
  (close FILE)
  (setq BRLIST0 (reverse BRLIST0)
        BRLIST1 (reverse BRLIST1)
        BRLIST2 (reverse BRLIST2)
        BRLIST3 (reverse BRLIST3)
        BRLIST4 (reverse BRLIST4))

; -------------------------- Required Routines Section
  (defun UP_SCL ()
   (if (= UNITS "0") (progn
     (cond
       ((= SCALE "0") (setq LTSCL 1 DIMSCL 1) (set_tile "ltscl" "1")
                      (set_tile "dimscl" "1"))
       ((= SCALE "1") (setq LTSCL 48 DIMSCL 96) (set_tile "ltscl" "48")
                      (set_tile "dimscl" "96"))
       ((= SCALE "2") (setq LTSCL 24 DIMSCL 48) (set_tile "ltscl" "24")
                      (set_tile "dimscl" "48"))
       ((= SCALE "3") (setq LTSCL 16 DIMSCL 32) (set_tile "ltscl" "16")
                      (set_tile "dimscl" "32"))
       ((= SCALE "4") (setq LTSCL 12 DIMSCL 24) (set_tile "ltscl" "12")
                      (set_tile "dimscl" "24"))
       ((= SCALE "5") (setq LTSCL 8 DIMSCL 16) (set_tile "ltscl" "8")
                      (set_tile "dimscl" "16"))
       ((= SCALE "6") (setq LTSCL 6 DIMSCL 12) (set_tile "ltscl" "6")
                      (set_tile "dimscl" "12"))
       ((= SCALE "7") (setq LTSCL 4 DIMSCL 8) (set_tile "ltscl" "4")
                      (set_tile "dimscl" "8"))
       ((= SCALE "8") (setq LTSCL 2 DIMSCL 4) (set_tile "ltscl" "2")
                      (set_tile "dimscl" "4"))
       ((= SCALE "9") (setq LTSCL 1 DIMSCL 2) (set_tile "ltscl" "1")
                      (set_tile "dimscl" "2"))
     )
    );progn
    (progn
     (cond
       ((= SCALE "0") (setq LTSCL 1 DIMSCL 1) (set_tile "ltscl" "1")
                      (set_tile "dimscl" "1"))
       ((= SCALE "1") (setq LTSCL 6 DIMSCL 12) (set_tile "ltscl" "6")
                      (set_tile "dimscl" "12"))
       ((= SCALE "2") (setq LTSCL 60 DIMSCL 120) (set_tile "ltscl" "60")
                      (set_tile "dimscl" "120"))
       ((= SCALE "3") (setq LTSCL 120 DIMSCL 240) (set_tile "ltscl" "120")
                      (set_tile "dimscl" "240"))
       ((= SCALE "4") (setq LTSCL 180 DIMSCL 360) (set_tile "ltscl" "180")
                      (set_tile "dimscl" "360"))
       ((= SCALE "5") (setq LTSCL 240 DIMSCL 480) (set_tile "ltscl" "240")
                      (set_tile "dimscl" "480"))
       ((= SCALE "6") (setq LTSCL 300 DIMSCL 600) (set_tile "ltscl" "300")
                      (set_tile "dimscl" "600"))
       ((= SCALE "7") (setq LTSCL 360 DIMSCL 720) (set_tile "ltscl" "360")
                      (set_tile "dimscl" "720"))
     )
  ))
  )
(defun do_snp (SX)
  (if (= SX 1) (mode_tile "snpsz" 0) (mode_tile "snpsz" 1)))

(defun do_grd (GX)
  (if (= GX 1) (mode_tile "grdsz" 0) (mode_tile "grdsz" 1))
)

(defun do_prec (UNT1)
  (if (= UNT1 "0") (setq UNT SLIST2) (setq UNT SLIST3))
  (start_list "prec")
  (mapcar 'add_list UNT)
  (end_list)
)

(defun do_scale (SCLE1)
  (if (= SCLE1 "0") (setq SCLE SLIST4) (setq SCLE SLIST5))
  (start_list "scales")
  (mapcar 'add_list SCLE)
  (end_list)
)

; ------------------------- Start List Section
  (start_list "units") (mapcar 'add_list SLIST1) (end_list)e
  (start_list "shtsz")  (mapcar 'add_list SLIST6) (end_list)
  (start_list "titlsh") (mapcar 'add_list BRLIST2) (end_list)
  (start_list "snpsz")  (mapcar 'add_list SLIST7)  (end_list)
  (start_list "grdsz")  (mapcar 'add_list SLIST8)  (end_list)
  (DO_PREC "0")
  (DO_SCALE "0")

; ------------------------- Set Tile Section
  (set_tile "error" "Copyright (c) Barry R. Bowen 1994")
  (set_tile "shtsz"  "5")  (set_tile "scales" "2")
  (set_tile "snpsz"  "1")  (set_tile "grdsz"  "0")
  (set_tile "orth"   "2")  (set_tile "snap"   "0")
  (set_tile "blip"   "0")  (set_tile "highl"  "2")
  (set_tile "ltscl"  "24") (set_tile "dimscl"  "48")

; ------------------------- Mode Tile Section
  (mode_tile "snpsz" 1)
  (mode_tile "grdsz" 1)

;-------------------------- Action Tile Section
  (action_tile "units"  "(setq UNITS $value) (DO_PREC UNITS) (DO_SCALE UNITS)")
  (action_tile "prec"   "(setq PREC $value)")
  (action_tile "scales" "(setq SCALE $value) (UP_SCL)")
  (action_tile "shtsz"  "(setq SHTSZ $value)")
  (action_tile "titlsh" "(setq BRSHT $value)")
  (action_tile "papsp"  "(setq PAPSP $value)")
  (action_tile "xref"   "(setq XREF $value)")
  (action_tile "intitl" "(setq INTITL $value)")
  (action_tile "ortho"  "(setq ORTHO $value)")
  (action_tile "snap"   "(setq SNAPM $value) (do_snp (atoi SNAPM))")
  (action_tile "grd"    "(setq GRD1 $value) (do_grd (atoi GRD1))")
  (action_tile "blip"   "(setq BLIP $value)")
  (action_tile "highl"  "(setq HIGHL $value)")
  (action_tile "snpsz"  "(setq SNPSZ $value)")
  (action_tile "grdsz"  "(setq GRD $value)")
  (action_tile "dimscl" "(setq DIMSCL (distof $value 4))")
  (action_tile "ltscl"  "(setq LTSCL (distof $value 4))")
  (action_tile "basic"  "(setq BASBR $value)")

  (action_tile "accept"  "(done_dialog 4)")
  (action_tile "cancel"  "(done_dialog 0)")

; ----------------- Start Dialog and Execute Selection
  (setq do_next (start_dialog))
  (unload_dialog dcl_id)

  (if (= do_next 4) (GO_SETUP))

);end main DEFUN

