; TIP1025.LSP: BEAM.LSP   Steel Beam Cross Section   (c)1994, Michael R. Benner

; A program to draw a beam cross section with a flange 
; width, beam depth, flange thickness, web thickness and rotation  
; angle supplied by the user. It is an enhanced version of LBEAM.LSP
; from the August, 1992 issue of CADalyst.

(defun dtr (A)
   (* pi (/ A 180.0))
)
(defun C:BEAM (/ FLANGE DEPTH FLTHK WTHK ANG P1 DEPTH2 FLANGE2 RAD
   P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 P12 )
   (setvar "CMDECHO" 0)
   (setq  
      FLANGE (getreal "\nFlange width: ")
      DEPTH (getreal "\nBeam depth: ")
      FLTHK (getreal "\nFLange thickness: ")
      WTHK (getreal "\nWeb thickness: ")
      ANG (getangle "\nRotation angle: ")
      P1 (getpoint "\nOrigin point: ")
   ) ; end of user input
   (if (= ANG nil) ;; for those who don't type in an angle above
      (setq ANG 0)
   )  
   (setq DEPTH2 (- DEPTH (* FLTHK 2))
      FLANGE2 (- (/ FLANGE 2) (/ WTHK 2)) 
      RAD (/ FLTHK 2)
   )
   (setq P2  (polar P1  ANG FLANGE)
      P3  (polar P2  (+ (dtr 90) ANG) FLTHK)
      P4  (polar P3  (+ (dtr 180) ANG) FLANGE2)
      P5  (polar P4  (+ (dtr 90) ANG) DEPTH2)
      P6  (polar P5  ANG FLANGE2)
      P7  (polar P6  (+ (dtr 90) ANG) FLTHK)
      P8  (polar P7  (+ (dtr 180) ANG) FLANGE)
      P9  (polar P8  (+ (dtr 270) ANG) FLTHK)
      P10 (polar P9  ANG FLANGE2)
      P11 (polar P10 (+ (dtr 270) ANG) DEPTH2)
      P12 (polar P11 (+ (dtr 180) ANG) FLANGE2)
   ) ; end of point definitions
   (command "line" P12 P1 P2 P3 "")
   (command "line" P6 P7 P8 P9 "")
   (command "pline" P6 "w" 0 0 P5 P4 P3 "")
   (command "fillet" "r" RAD "fillet" "polyline" "l")
   (command "pline" P12 "w" 0 0 P11 P10 P9 "")
   (command "fillet" "r" RAD "fillet" "polyline" "l")
   (redraw) ; end of drawing the outline and filleting
   (setvar "CMDECHO" 1)
) ; end of beam.lsp
