; TIP1028.LSP: DRAGBRK.LSP    Breaklines   (c)1994, Michael Jenkins

(defun C:DRAGBRK (/ PT1 PT2 PT3 PT4 PT5 PT6 PT7 _ORTHO ANG LEG)
   (defun _ortho (PT1 PT / ANG)
      (setq ANG (angle PT1 PT))
      (cond 
         ((or (<= ANG 0.7853) (> ANG 5.4977))
            (polar PT1 0 (distance PT1 PT)) 
         )
         ((and (> ANG 0.7853) (<= ang 2.3561))
            (polar PT1 1.5707 (distance PT1 PT)) 
         )
         ((AND (> ANG 2.3561) (<= ANG 3.9269))
            (polar PT1 3.14159 (distance PT1 PT)) 
         )
         ((and (> ANG 3.9269) (<= ANG 5.4977))
            (polar PT1 4.7124 (distance PT1 PT)) 
         )
      )
   )   
   (setq PT2 nil PT6 nil)
   (while 
      (not
         (setq PT1 (getpoint "\nPick starting point for break: "))
      )
      (prompt "\nInvalid point")
   )   
   (prompt "\nDrag to indicate size and angle of break: ")
   (while 
      (/= (car (setq GR (grread T 19))) 3) 
      (cond
         ((= (car GR) 5)
            (if (/= (car GR) PT1)
               (progn
                  (if PT2
                     (progn
                        (grdraw PT2 PT3 -1)
                        (grdraw PT3 PT4 -1)
                        (grdraw PT2 PT5 -1)
                     )
                  )  
                  (if
                     (= (getvar "orthomode") 0)
                     (setq GR_PT (cadr GR))
                     (setq GR_PT (_ortho PT1 (cadr GR)))
                  )
                  (setq
                     ANG (angle PT1 GR_PT)
                     LEG (distance gr_pt pt1)
                     PT2 (polar PT1 ANG LEG)
                     PT3 (polar PT1 (+ ANG 3.14159) LEG)
                     PT4 (polar PT1 (+ ANG 1.5707) (* LEG 0.4))
                     PT5 (polar PT1 (- ANG 1.5707) (* LEG 0.4))
                  )
                  (grdraw PT2 PT3 -1)
                  (grdraw PT3 PT4 -1)
                  (grdraw PT2 PT5 -1)
               )
            )
         )
         ((= (car GR) 2)
            (if
               (= (cadr GR) 194)
               (if 
                  (= (getvar "orthomode") 1)
                  (progn
                     (setvar "orthomode" 0)
                     (prompt "<Ortho off> ")
                  )   
                  (progn
                     (setvar "orthomode" 1)
                     (prompt "<Ortho on> ")
                  )   
               )   
            )   

         ) 
      )
   )
   (prompt "\nDrag to indicate length of lines: ")
   (while 
      (/= (car (setq GR (grread T))) 3) 
      (if
         (= (car GR) 5)
         (if (/= (car GR) PT1)
            (progn
               (if PT6
                  (progn
                     (grdraw PT4 PT7 -1)
                     (grdraw PT5 PT6 -1)
                  )
                )  
               (setq
                  GR_PT (cadr GR)
                  ANG (angle PT1 PT5)
                  LEG (* (distance GR_PT PT1) 1.4)
                  PT7 (polar PT4 (+ ANG 3.14159) LEG)
                  PT6 (polar PT5 ANG LEG)
               )
               (grdraw PT4 PT7 -1)
               (grdraw PT5 PT6 -1)
            )
         )
      ) 
   )
   ;create new pline using the dragged points
   (entmake 
      '(
         (0 . "POLYLINE")
      )
   )
   (foreach
      vertex
      (list PT7 PT4 PT3 PT2 PT5 PT6)  
      (entmake 
         (list
            '(0 . "VERTEX")
            (cons 10 (list (car VERTEX) (cadr VERTEX)))
         )
      )
   )
   (entmake '((0 . "SEQEND")))
   (princ)
); end dragbrk.lsp

